class CRC8:
    @classmethod
    def getCRC(cls, message):
        crc = 0
        for i in range(2, message[1] + 2):
            crc = cls.AddStep2CRC(crc, message[i])
        return crc

    @classmethod
    def AddStep2CRC(cls, crc, nextByte):
        crc = (crc ^ nextByte) & 0xFF  # xor with nextByte
        for j in reversed(range(0, 8)):
            if (crc & 0x80) == 0x80:
                crc = (((crc << 1) & 0xFF) ^ 0x97) & 0xFF
            else:
                crc = (crc << 1) & 0xFF
        return crc

    @classmethod
    def VerifyCRC(cls, bytes):
        crc = cls.getCRC(bytes[:-1])
        return crc == bytes[-1]
