from app_logging import AppLogger
from CRC8 import CRC8


def get_message(ser):
    log = AppLogger()
    data = []
    count = 0
    while True:
        if count == 0:
            d = ser.read(1)
            try:
                bob = d[0]
            except Exception as a:
                # log.info('This is the failing exception: {}'.format(a))
                return None
            if d[0] == 0xc5:
                data += d
                count += 1
            else:
                log.info('Did not receive Start delimiter: {}'.format(d))
                return None  # didn't receive start delimeter in time
        else:
            data += ser.read(1)
            count += 1
            if len(data) >= 2:
                if count == (data[1] + 3):
                    break
            else:
                log.info('Did not received length: {}'.format(data))
                return None  # didn't receive Length byte need to interpret this
    check = CRC8()
    if not check.VerifyCRC(data):  # data may be in the wrong format
        log.info('failing CRC')
        return None
    else:
        return data


def send_message(ser, message):
    if type(message) is not bytearray:
        message = bytearray(message)
    # ser.reset_input_buffer()
    ser.write(message)
    return
