var autoRefreshRate = 1;// in seconds
var commandBlockTime = 1;// in seconds
$(function(){
	retrieveStatus();
	retrieveSettings();
	
	$('.commandButton').click(sendCommand);
	$('#btnCancel').click(retrieveSettings);
	$( "form" ).on( "submit", submitForm);
});

var refreshHandle;
function retrieveStatus()
{
	if(!refreshHandle){ 
		refreshHandle = setInterval(retrieveStatus, autoRefreshRate * 1000);//seconds * 1000 miliseconds
	}
	
	$.get('status.json',function(data){
		var obj = JSON.parse(data);
		$('#gatewayID').html(obj.gatewayid);
		$('#apnState').html(obj.state);
		$('#deviceCount').html(obj.devices);
		
		if(obj.state == 'Busy')
		{ setBusy(); }
		else
		{ setReady(); }
	
		if(obj.state == 'Idle')
		{
			$('#start').show();
			$('#stop').hide();
		}
		else
		{
			$('#start').hide();
			$('#stop').show();
		}
	    if(obj.state == 'Active')
	    {
	        $('#usb-icon').removeClass('statusInactive');
	        $('#usb-icon').addClass('statusOK');
	    }
	    else
	    {
	        $('#usb-icon').removeClass('statusOK');
	        $('#usb-icon').addClass('statusInactive');
	    }
	});
}

function setBusy()
{
	$('#apnState').html('Busy');
	$('.btn-primary').addClass('btn-disable');
	$('.btn-primary').removeClass('btn-primary');
	$('#usb-icon').removeClass('statusOK');
    $('#usb-icon').addClass('statusInactive');
}

function setReady()
{
	$('.btn-disable').addClass('btn-primary');
	$('.btn-disable').removeClass('btn-disable');
}

function retrieveSettings()
{
	$.get('settings.json',function(data){
		var obj = JSON.parse(data);
//		$('#hostName').val(obj.host);
//		$('#port').val(obj.port);
		$('#heartbeat').val(obj.heartbeat);
		$('#transmitAware').prop("checked",obj.aware);
//		$('#encryptionKey').val(obj.encryption);
        $('#error').val(obj.error);
	});
}

function sendCommand()
{
	//Disabled due to busy status
	if($(this).hasClass("btn-disable")) return;
	
	if(refreshHandle){ 
		clearInterval(refreshHandle); 
		refreshHandle = null;
	}
	setBusy();
	
	$.post("","command=" + $(this).data("command"),function(data){
		setTimeout(retrieveStatus,commandBlockTime * 1000);//seconds * 1000 miliseconds
	});
}



function submitForm(event)
{
	event.preventDefault();
	  
	//Disabled due to busy status
	if($("button[type='submit']").hasClass("btn-disable")) return;
	
	if(refreshHandle){ 
		clearInterval(refreshHandle); 
		refreshHandle = null;
	}
	setBusy();
	
	$.post("",$(this).serialize(),function(data){

		$('#error').html(data);
		setTimeout(retrieveStatus,commandBlockTime * 1000);//seconds * 1000 miliseconds
	});
}